#include <windows.h>
#include <shellapi.h>
#include <stdio.h>
#include <string.h>
#include <commdlg.h>
#include <dir.h>
#include <stdlib.h>

#define MAXOPT 6
#define MAXSHOW 6
#define MAXSTR 1024
HWND hMyWindow, opt[MAXOPT + MAXSHOW], hDepth, hIndex, hStart, hClose, hAdd, hResults, hList, hListBox, hSave, hClear;
BOOL bResults = FALSE, bDialog = FALSE;
int Width = 470, Height = 258, Height2 = 480;
char Depth[MAXSTR], Index[MAXSTR], IndexTitle[MAXSTR];
char out[MAXSTR], path[MAXSTR];

char topt[][55] = {
	"Zkontrolovat tak dokumenty, na n vede odkaz",
	"Hloubku prochzen omezit na:",
	"Pi odkazu na adres pout soubor",
	"Kontrolovat tak odkazy vedouc do koenovho adrese",
	"Rozliovat mal a velk psmena v nzvech soubor",
	"Po skonen zobrazit celkovou statistiku",
	"Zpracovan soubory",
	"Hloubka odkaz",
	"Nezkontrolovan odkazy",
	"Odkazy v podku",
	"Dve zkontrolovan odkazy",
	"Odkazy do tho dokumentu",
};


char sbuf[MAXSTR];

struct file {
	unsigned check:1; //kontrolovat tento soubor
	char *name;
	int depth; //hloubka rekurze
	struct file *next;
};

struct files {
	struct file *first;
	struct file *f; //souasn pozice
	struct file *g; //nov zznamy pidvat za
	struct file *last;
} *f;

struct param {
	unsigned recursive:1;
	unsigned dvojtecka:1;
	unsigned vypisok:1;
	unsigned dvojkriz:1;
	unsigned printskip:1;
	unsigned printdepth:1;
	unsigned root:1;
	unsigned info:1;
	unsigned isindex:1;
	unsigned sensitive:1;
	unsigned stat:1;
	int depth;
	char *index;
};

struct stat {
	int maxdepth;
	int check;
	int good;
	int bad;
	int in;
	int out;
	int skip;
};



int printinfo(char action, struct param *param, struct stat *stat, char *name, int line, char *out, int depth) {
	int print;
	switch (action) {
		case '*': print = param->vypisok; stat->good++; break;
		case '!': print = 1; stat->bad++; break;
		case '#': print = param->dvojkriz; stat->in++; break;
		case ':': print = param->dvojtecka; stat->out++; break;
		case '@': print = param->printskip; stat->skip++; break;
		default: print = 0;
	}
	if (print) {
		if (param->printdepth) sprintf(sbuf, "%d%c %s (%d): %s", depth, action, name, line, out);
		else sprintf(sbuf, "%c %s (%d): %s", action, name, line, out);
		SendDlgItemMessage(hMyWindow, 5, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) sbuf));
	}
	return 0;
}

int create(struct files **f) {
	*f = (files *) malloc(sizeof(struct files));
	(*f)->first = (*f)->f = (*f)->g = (*f)->last = NULL;
	return 1;
}

int clear(struct files *f) {
	if (f->first) {
		for (f->f = f->first, f->g = f->first->next; f->g; f->f = f->g, f->g = f->g->next)
			free(f->f);
		free(f->f);
	}
	f->first = f->f = f->g = f->last = NULL;
	return 1;
}

int check(struct files *f, char *name, int sensitive) {
	struct file *g;

	for (g=f->first; g; g=g->next) {
		if ((sensitive && !strcmp(g->name, name))
		|| (!sensitive && !strcmpi(g->name, name)))
			return 1;
	}
	return 0;
}

int add(struct files *f, char *fname, int sensitive, int depth, int maxdepth, struct stat *stat, int fcheck) {
	struct file *g;
	char *s, *name;

	if (maxdepth != -1 && depth > maxdepth) return 0;
	if (stat && depth > stat->maxdepth) stat->maxdepth = depth;
	name = strdup(fname);
	while (s = strchr(name, '\\')) *s = '/';
	if (check(f, name, sensitive)) {
		free(name);
		return 0;
	}
	g = (file *) malloc(sizeof(struct file));
	if (f->f) {
		g->next = f->g->next;
		f->g->next = g;
	}
	else {
		f->first = f->f = f->g = f->last = g;
		g->next = NULL;
	}
	g->name = name;
	g->depth = depth;
	g->check = fcheck;
	f->g = g;
	return 1;
}



#define OUTSTAVY 7
int outf(int outstav, int out, char *s) {
//out: 0 bn text, 1 znaka, 2 atribut, 3 hodnota
	switch (out) {
		case 1:
			if (!strcmpi(s, "A")) return 1;
			if (!strcmpi(s, "FRAME")) return 2;
			if (!strcmpi(s, "AREA")) return 3;
			if (!strcmpi(s, "IMG")) return 4;
			if (!strcmpi(s, "LINK")) return 5;
			if (!strcmpi(s, "SCRIPT")) return 6;
			if (!strcmpi(s, "FORM")) return 7;
			break;
		case 2:
			switch ((outstav-1) % OUTSTAVY + 1) {
				case 1: case 3: case 5: return outstav + OUTSTAVY * !strcmpi(s, "HREF");
				case 2: case 6: return outstav + OUTSTAVY * !strcmpi(s, "SRC");
				case 4: return outstav + OUTSTAVY * (!strcmpi(s, "SRC") || !strcmpi(s, "LOWSRC"));
				case 7: return outstav + OUTSTAVY * !strcmpi(s, "ACTION");
			}
			break;
		case 3:
			if (outstav > OUTSTAVY) return 2*OUTSTAVY+1 + (outstav-1) % OUTSTAVY;
			if (outstav) return 1 + (outstav-1) % OUTSTAVY;
			break;
	}
	return 0;
}

char *makepath(char *path, char *name1, char *name2, char *index) {
	int i=0;
	char *s, *s2, *s3;
	struct ffblk ff;

	if (!path) return NULL;
	if (!name2) return strcpy(path, name1);
	if (name1 && *name2 != '/' && (s=strrchr(name1, '/'))) {
		strcpy(path, name1);
		i = s - name1 + 1;
	}
	strcpy(path+i, name2);
	if (s = strchr(path, '#')) *s=0;
	if (s = strchr(path, '?')) *s=0;
	if (path[strlen(path)-1] == '/') strcat(path, index);
	else if (!findfirst(path, &ff, 0xff) && ff.ff_attrib & 0x10)
		strcat(strcat(path, "/"), index);
	for (s2=path; s=strstr(s2, "/../"); ) {
		*s = 0;
		if (s3 = strrchr(s2, '/')) s3++;
		else s3 = s2;
		if (strncmp(s3, "..", 2)) strcpy(s3, s+4);
		else { *s = '/'; s2 += 3; }
	}
	for (s=path; s=strstr(s, "./"); ) {
		if (s == path || *(s-1) != '.') strcpy(s, s+2);
		else s += 2;
	}
	return path;
}

int htmlhref(struct files *f, struct param *param, struct stat *stat) {
	FILE *file, *file2;
	int i, j, stav, jinak, lambda, outcount=0, outstav=0, line=1;

	int stavy[][9] = {
		{ 0, 0,'<', 1,-1},
		{ 2,-1,' ', 1,'>',0,'!',9,-1},
		{ 2, 1,' ', 3,'>',0,-1},
		{ 4,-1,' ', 3,'>',0,-1},
		{ 4, 2,' ', 5,'>',0,'=',6,-1},
		{ 4,-1,' ', 5,-1},
		{ 8,-1,' ', 6,'"',7,-1},
		{ 7, 3,'"', 3,-1},
		{ 8, 3,' ', 3,'>',0,-1},
		{ 9,-1,'-',10,'>',0,-1},
		{ 9,-1,'-',11,-1},
		{11,-1,'-',12,-1},
		{11,-1,'-',13,-1},
		{13,-1,'-',14,'>',0,-1},
		{13,-1,'-',11,'>',0,-1},
	};

	while (!(file = fopen(f->f->name, "r"))) {
		sprintf(sbuf, "Nelze otevt vstupn HTML soubor '%s'.", f->f->name);
		if (MessageBox(hMyWindow, sbuf, "HTMLhref", MB_RETRYCANCEL) != IDRETRY)
			return 2;
	}

	for (lambda=0, stav=0; lambda || (i=getc(file)) != EOF; ) {
		if (i == '\n') line++;
		lambda=0;
		if (stavy[stav][1] >= 0) out[outcount++] = i;
		for (jinak=1, j=2; stavy[stav][j] != -1; j=j+2)
			if (stavy[stav][j] == i || outcount == MAXSTR-1 || (i == ' ' && (stavy[stav][j] == '\n' || stavy[stav][j] == '\r'))) {
				if (stavy[stav][1] >= 0 || outcount == MAXSTR-1) {
					out[outcount - (outcount == MAXSTR-1 ? 0 : 1)]=0;
					outstav = outf(outstav, stavy[stav][1], out);
					if (outstav > 2*OUTSTAVY) {

						if (*out == '#') printinfo('#', param, stat, f->f->name, line, out, f->f->depth);
						else if (strchr(out, ':')) printinfo('?', param, stat, f->f->name, line, out, f->f->depth);
						else if (param->root || *out != '/') {
							makepath(path, f->f->name, out, param->index);
							if (!check(f, path, param->sensitive)) {
								if (!(file2 = fopen(path, "r"))) printinfo('!', param, stat, f->f->name, line, out, f->f->depth);
								else {
									fclose(file2);
									printinfo('*', param, stat, f->f->name, line, out, f->f->depth);
								}
								add(f, path, param->sensitive, f->f->depth + 1, param->depth, stat
								, param->recursive && outstav - 2*OUTSTAVY <= 3 && file2);
							}
							else printinfo('@', param, stat, f->f->name, line, out, f->f->depth);
						}

						outstav = 1 + (outstav-1) % OUTSTAVY;
					}
					outcount=0;
				}
				stav=stavy[stav][j+1];
				jinak=0;
				break;
			}
		if (jinak && stav != stavy[stav][0]) {
			lambda=1;
			stav=stavy[stav][0];
		}
	}
	fclose(file);
	return 0;
}

int MyMain(void) {
	struct param param;
	struct stat stat = {0,0,0,0,0,0,0};
	char *out, path[512];

	GetWindowText(hDepth, Depth, MAXSTR-1);
	param.recursive  = IsDlgButtonChecked(hMyWindow, 100);
	param.depth      =(IsDlgButtonChecked(hMyWindow, 101) ? atoi(Depth) : -1);
	param.isindex    = IsDlgButtonChecked(hMyWindow, 102);
	param.root       = IsDlgButtonChecked(hMyWindow, 103);
	param.sensitive  = IsDlgButtonChecked(hMyWindow, 104);
	param.stat       = IsDlgButtonChecked(hMyWindow, 105);
	param.info       = IsDlgButtonChecked(hMyWindow, 106);
	param.printdepth = IsDlgButtonChecked(hMyWindow, 107);
	param.dvojtecka  = IsDlgButtonChecked(hMyWindow, 108);
	param.vypisok    = IsDlgButtonChecked(hMyWindow, 109);
	param.printskip  = IsDlgButtonChecked(hMyWindow, 110);
	param.dvojkriz   = IsDlgButtonChecked(hMyWindow, 111);
	param.index      = IndexTitle;

	if (!f->first)
		if (*Index) { 
			sprintf(sbuf, "Nezadali jste dn soubory ke zkontrolovn, zadali jste vak soubor pro odkaz na adres. Pejete si zkontrolovat soubor '%s'?", Index);
			if (MessageBox(hMyWindow, sbuf, "HTMLhref", MB_YESNO | MB_ICONQUESTION) == IDYES)
				add(f, Index, param.sensitive, 0, param.depth, &stat, 1);
			else return 0;
		}
		else {
			MessageBox(hMyWindow, "Nezadali jste dn soubory ke zkontrolovn. Mete tak uinit kliknutm na tlatko 'Pidat soubor'", "HTMLhref", MB_OK | MB_ICONINFORMATION);
			return 0;
		}

	out = (char *) malloc(MAXSTR);
	for (f->f = f->first; f->f; f->g = f->f = f->f->next) {
		if (f->f->check) {
			stat.check++;
			if (param.info) SendDlgItemMessage(hMyWindow, 5, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) f->f->name));
			htmlhref(f, &param, &stat);
		}
	}
	free(out);

	if (param.stat) {
		sprintf(sbuf, "prozkoumanch soubor: %d\nnalezench odkaz: %d\nmaximln dosaen hloubka: %d\n\nOdkazy v podku (*): %d\nVadn odkazy (!): %d\nOdkazy do tho dokumentu (#): %d\nNezkontrolovan odkazy (:): %d\nDve zkontrolovan odkazy (@): %d", stat.check, stat.good + stat.bad + stat.in + stat.out + stat.skip, stat.maxdepth, stat.good, stat.bad, stat.in, stat.out, stat.skip);
		MessageBox(hMyWindow, sbuf, "HTMLhref", MB_OK | MB_ICONINFORMATION);
	}
}

LRESULT CALLBACK MyWinProc(HWND hWin, UINT msg, WPARAM wParam, LPARAM lParam) {
	char szFile[MAXSTR] = "";
	char szFileTitle[MAXSTR] = "";
	OPENFILENAME ofn;
	PAINTSTRUCT ps;
	RECT rc;
	HDC dc;
	RECT MyRc, DesktopRc;
	GetWindowRect(hMyWindow, &MyRc);
	GetWindowRect(GetDesktopWindow(), &DesktopRc);
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWin;
	ofn.lpstrFile= szFile;
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFileTitle= szFileTitle;
	ofn.nMaxFileTitle = sizeof(szFileTitle);
	ofn.lpstrInitialDir = NULL;

	switch (msg) {
		case WM_COMMAND:
			switch (wParam) {
				case IDOK:
					bDialog = TRUE;
					HCURSOR OldCursor = SetCursor(LoadCursor(NULL, IDC_WAIT));
					MyMain();
					if (OldCursor) SetCursor(OldCursor);
					bDialog = FALSE;
					clear(f);
					return 0;
				case IDCANCEL:
					bDialog = TRUE;
					if (MessageBox(hMyWindow, "Pejete si ukonit program?", "HTMLhref", MB_ICONQUESTION | MB_YESNO) == IDYES) {
						/*
						HKEY hKey;
						if (RegCreateKey(HKEY_CLASSES_ROOT, "HKEY_CURRENT_USER\\Software\\Jakub Vrna\\HTMLhref", &hKey) == ERROR_SUCCESS) {
							for (int i=0; i<MAXOPT+MAXSHOW; i++) if (i != 3) {
								sprintf(sbuf, "opt[%d]", i);
								if (IsDlgButtonChecked(hMyWindow, 100+i))
									RegSetValue(hKey, sbuf, REG_SZ, "1", 0);
							}
							RegCloseKey (hKey);
						}
						*/
						PostQuitMessage(0);
					}
					bDialog = FALSE;
					return 0;
				case 3: //Pidat soubor
					ofn.lpstrFilter = "Vechny soubory (*.*)\0*.*\0HTML dokumenty (*.htm)\0*.htm\0\0";
					ofn.nFilterIndex = 2;
					ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
					bDialog = TRUE;
					if (GetOpenFileName(&ofn)) {
						add(f, szFile, IsDlgButtonChecked(hMyWindow, 104), 0, 0, NULL, 1);
					}
					bDialog = FALSE;
					return 0;
				case 4: //Vsledky
					if (bResults = !bResults) {
						if (MyRc.top + Height2 > DesktopRc.bottom)
							MyRc.top = (DesktopRc.bottom - DesktopRc.top - Height2) / 2; 
						SetWindowPos(hMyWindow, NULL, MyRc.left, MyRc.top, Width, Height2, 0);
					}
					else {
						SetWindowPos(hMyWindow, NULL, MyRc.left, MyRc.top, Width, Height, 0);
					}
					return 0;
				case 6: //Uloit vsledky
					if (!SendDlgItemMessage(hMyWindow, 5, LB_GETCOUNT, 0, 0))
						MessageBox(hMyWindow, "Pole s vsledky je przdn.", "HTMLhref", MB_ICONINFORMATION | MB_OK);
					else {
						ofn.lpstrFilter = "Vechny soubory (*.*)\0*.*\0Textov soubory (*.txt)\0*.txt\0\0";
						ofn.nFilterIndex = 2;
						ofn.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
						bDialog = TRUE;
						if (GetSaveFileName(&ofn)) {
							FILE *file = fopen(szFile, "w");
							for (int i=0; i < SendDlgItemMessage(hMyWindow, 5, LB_GETCOUNT, 0, 0); i++) {
								SendDlgItemMessage(hMyWindow, 5, LB_GETTEXT, i, (LPARAM) ((LPSTR) sbuf));
								fprintf(file, "%s\n", sbuf);
							}
							fclose(file);
						}
						bDialog = FALSE;
					}

					return 0;
				/*
				case 7: //maximln hloubka
					GetWindowText(hDepth, Depth, MAXSTR-1);
					MessageBox(hMyWindow, "Ahoj", "", 0);
					for (int i=0; i<strlen(Depth); )
						if (Depth[i] >= '0' && Depth[i] <= '9') i++;
						else strcpy(Depth + i, Depth + i + 1);
					SetWindowText(hDepth, Depth);
					return 0;
				*/
				case 8: //Vyistit vsledky
					if (!SendDlgItemMessage(hMyWindow, 5, LB_GETCOUNT, 0, 0))
						MessageBox(hMyWindow, "Pole s vsledky je przdn.", "HTMLhref", MB_ICONINFORMATION | MB_OK);
					else SendDlgItemMessage(hMyWindow, 5, LB_RESETCONTENT, 0, 0);
					return 0;
				case 100: //rekurze
					if (!IsDlgButtonChecked(hMyWindow, 100)) {
						CheckDlgButton(hMyWindow, 101, FALSE);
						EnableWindow(hDepth, FALSE);
					}
					EnableWindow(opt[1], IsDlgButtonChecked(hMyWindow, 100));
					return 0;
				case 101: //omezen rekurze
					EnableWindow(hDepth, IsDlgButtonChecked(hMyWindow, 101));
					return 0;
				case 102: //index
					ofn.lpstrFilter = "Vechny soubory (*.*)\0*.*\0HTML dokumenty (*.htm)\0*.htm\0\0";
					ofn.nFilterIndex = 2;
					ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
					bDialog = TRUE;
					if (!IsDlgButtonChecked(hMyWindow, 102) || !GetOpenFileName(&ofn)) {
						strcpy(Index, "");
						strcpy(IndexTitle, "");
						CheckDlgButton(hMyWindow, 102, FALSE);
					}
					else {
						strcpy(Index, szFile);
						strcpy(IndexTitle, szFileTitle);
						CheckDlgButton(hMyWindow, 102, TRUE);
					}
					bDialog = FALSE;
					SetWindowText(hIndex, IndexTitle);
					return 0;
				default: return DefWindowProc(hWin, msg, wParam, lParam);
			}
		case WM_WINDOWPOSCHANGING:
			if (bDialog) return 1;
			WINDOWPOS *pwp = (WINDOWPOS *) lParam;
			pwp->cx = Width; if (pwp->cy)
			if (pwp->cy < (Height + Height2) / 2) {
				pwp->cy = Height;
				bResults = FALSE;
				SetWindowText(hResults, "&Vsledky >>");

				for (int i=MAXOPT; i<MAXOPT+MAXSHOW; i++)
					EnableWindow(opt[i], FALSE);
				EnableWindow(hList, FALSE);
				EnableWindow(hClear, FALSE);
				EnableWindow(hSave, FALSE);
			}
			else {
				if (pwp->cy < Height2) pwp->cy = Height2;
				bResults = TRUE;
				SetWindowText(hResults, "&Vsledky <<");

				for (int i=MAXOPT; i<MAXOPT+MAXSHOW; i++)
					EnableWindow(opt[i], TRUE);
				EnableWindow(hList, TRUE);
				EnableWindow(hClear, TRUE);
				EnableWindow(hSave, TRUE);

				SetWindowPos(hList, NULL, 0, 0, 430, 16 * ((pwp->cy - 430) / 16) + 2, SWP_NOZORDER | SWP_NOMOVE);
				SetWindowPos(hListBox, NULL, 0, 0, 432, 16 * ((pwp->cy - 430) / 16) + 2, SWP_NOZORDER | SWP_NOMOVE);
				SetWindowPos(hClear, NULL, 188, pwp->cy - 66, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
				SetWindowPos(hSave, NULL, 328, pwp->cy - 66, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}
			return 0;
		case WM_CLOSE:
			PostMessage(hWin, WM_COMMAND, IDCANCEL, 0);
			return 0;
		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;
		default: return DefWindowProc(hWin, msg, wParam, lParam);
	}
}


int WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszParams, int nShow) {
	WNDCLASS MyWinClass;
	MSG msg;
	HWND hWin;
	int i;

	if (!hPrevInstance) {
		MyWinClass.style = 0;
		MyWinClass.lpfnWndProc = MyWinProc;
		MyWinClass.cbClsExtra = 0;
		MyWinClass.cbWndExtra = 0;
		MyWinClass.hInstance = hInstance;
		MyWinClass.hIcon = LoadIcon(hInstance, "TheIcon");
		MyWinClass.hCursor = LoadCursor(NULL, IDC_ARROW);
		MyWinClass.hbrBackground = CreateSolidBrush(RGB(255, 255, 255));
		MyWinClass.lpszMenuName = NULL;
		MyWinClass.lpszClassName = "MyClass";
		if (!RegisterClass(&MyWinClass)) return (FALSE);
	}

	CREATESTRUCT csm, css;
	RECT rc;
	GetWindowRect(GetDesktopWindow(), &rc);

	hMyWindow = CreateWindow("MyClass", "HTMLhref", WS_OVERLAPPEDWINDOW, (rc.right - rc.left - Width) / 2, (rc.bottom - rc.top - Height - 40) / 2, Width, Height, HWND_DESKTOP, NULL, hInstance, &csm); if (!hMyWindow) return (FALSE);
	hWin = CreateWindow("Button", "&Monosti", WS_CHILD | BS_GROUPBOX, 16, 8, 432, 176, hMyWindow, 0, hInstance, &css); if (!hWin) return (FALSE); ShowWindow(hWin, SW_SHOWNORMAL);

	for (i=0; i<MAXOPT; i++) {
		if (i==1) {
			opt[i] = CreateWindow("Button", topt[i], WS_CHILD | WS_TABSTOP | WS_DISABLED | BS_AUTOCHECKBOX, 56, 32 + 24*i, 220, 20, hMyWindow, 100+i, hInstance, &css);
			hWin = CreateWindow("Static", "", WS_CHILD | SS_BLACKFRAME, 280, 55, 50, 22, hMyWindow, 0, hInstance, &css); if (!hWin) return (FALSE); ShowWindow(hWin, SW_SHOWNORMAL);
			hDepth = CreateWindow("Edit", Depth, WS_CHILD | WS_TABSTOP | WS_DISABLED | ES_LEFT | ES_OEMCONVERT | ES_AUTOHSCROLL, 281, 56, 48, 20, hMyWindow, 7, hInstance, &css); if (!hDepth) return (FALSE); ShowWindow(hDepth, SW_SHOWNORMAL);
			hWin = CreateWindow("Static", "rovn", WS_CHILD | SS_LEFT, 336, 57, 44, 16, hMyWindow, 0, hInstance, &css); if (!hWin) return (FALSE); ShowWindow(hWin, SW_SHOWNORMAL);
		}
		else opt[i] = CreateWindow("Button", topt[i], WS_CHILD | WS_TABSTOP | BS_AUTOCHECKBOX, 32, 32 + 24*i, 400, 20, hMyWindow, 100+i, hInstance, &css);
		if (!opt[i]) return (FALSE); ShowWindow(opt[i], SW_SHOWNORMAL);
	}

	hIndex = CreateWindow("Static", "", WS_CHILD | SS_LEFT, 300, 81, 100, 16, hMyWindow, 0, hInstance, &css); if (!hIndex) return (FALSE); ShowWindow(hIndex, SW_SHOWNORMAL);
	hStart = CreateWindow("Button", "&Start", WS_CHILD | WS_TABSTOP | BS_DEFPUSHBUTTON, 16, 192, 96, 28, hMyWindow, IDOK, hInstance, &css); if (!hStart) return (FALSE); ShowWindow(hStart, SW_SHOWNORMAL);
	hClose = CreateWindow("Button", "&Konec", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON, 120, 192, 96, 28, hMyWindow, IDCANCEL, hInstance, &css); if (!hClose) return (FALSE); ShowWindow(hClose, SW_SHOWNORMAL);
	hAdd = CreateWindow("Button", "&Pidat soubor", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON, 224, 192, 120, 28, hMyWindow, 3, hInstance, &css); if (!hAdd) return (FALSE); ShowWindow(hAdd, SW_SHOWNORMAL);
	hResults = CreateWindow("Button", "&Vsledky >>", WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON, 352, 192, 96, 28, hMyWindow, 4, hInstance, &css); if (!hResults) return (FALSE); ShowWindow(hResults, SW_SHOWNORMAL);
	hWin = CreateWindow("Button", "&Zobrazen", WS_CHILD | BS_GROUPBOX, 16, 232, 432, 104, hMyWindow, 0, hInstance, &css); if (!hWin) return (FALSE); ShowWindow(hWin, SW_SHOWNORMAL);

	for (i=MAXOPT; i<MAXOPT+MAXSHOW; i++) {
		opt[i] = CreateWindow("Button", topt[i], WS_CHILD | WS_TABSTOP | WS_DISABLED | BS_AUTOCHECKBOX, 32 + 200*(i>=MAXOPT+3), 256 + 24*((i-MAXOPT) % 3), (i<MAXOPT+3) ? 184 : 208, 20, hMyWindow, 100+i, hInstance, &css);
		if (!opt[i]) return (FALSE);
		ShowWindow(opt[i], SW_SHOWNORMAL);
	}

	hListBox = CreateWindow("Static", "", WS_CHILD | SS_BLACKFRAME, 16, 352, 0, 0, hMyWindow, 0, hInstance, &css); if (!hListBox) return (FALSE); ShowWindow(hListBox, SW_SHOWNORMAL);
	hList = CreateWindow("Listbox", "", WS_CHILD | WS_TABSTOP | WS_VSCROLL | WS_DISABLED | LBS_HASSTRINGS, 18, 354, 0, 0, hMyWindow, 5, hInstance, &css); if (!hList) return (FALSE); ShowWindow(hList, SW_SHOWNORMAL);
	hClear = CreateWindow("Button", "V&yistit vsledky", WS_CHILD | WS_TABSTOP | WS_DISABLED | BS_PUSHBUTTON, 188, 496, 132, 28, hMyWindow, 8, hInstance, &css); if (!hClear) return (FALSE); ShowWindow(hClear, SW_SHOWNORMAL);
	hSave = CreateWindow("Button", "&Uloit vsledky", WS_CHILD | WS_TABSTOP | WS_DISABLED | BS_PUSHBUTTON, 328, 496, 120, 28, hMyWindow, 6, hInstance, &css); if (!hSave) return (FALSE); ShowWindow(hSave, SW_SHOWNORMAL);

	/*
	HKEY hKey;
	if (RegOpenKey(HKEY_CLASSES_ROOT, "HKEY_CURRENT_USER\\Software\\Jakub Vrna\\HTMLhref", &hKey) == ERROR_SUCCESS) {
		LONG bufsize = MAXSTR;
		char s[MAXSTR];
		for (i=0; i<MAXOPT+MAXSHOW; i++) if (i != 3) {
			sprintf(sbuf, "opt[%d]", i); 
			if (RegQueryValue(hKey, sbuf, s, &bufsize) == ERROR_SUCCESS && strcmp(s, "1"))
				CheckDlgButton(hMyWindow, 100+i, TRUE);
		}
		RegCloseKey (hKey);
	}
	*/

	SetFocus(hAdd);
	ShowWindow(hMyWindow, SW_SHOWNORMAL);

	create(&f);

	while (GetMessage(&msg, NULL, 0, 0)) if (!IsDialogMessage(hMyWindow, &msg)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}
